//ESDSAIXD JOB (001),'ESDS AIX DEMO',CLASS=S,MSGCLASS=M
//*
//* *********************************************************
//* * DEMONSTRATES USE OF ALTERNATE INDEXES TO ACCESS DATA  *
//* * RECORDS STORED IN ESDS CLUSTER. STEPS BELOW ARE:      *
//* *                                                       *
//* *  IDCAMS1: DELETE/DEFINE ESDS CLUSTER FOR DATA         *
//* *  COBUCLG1: LOAD TEST DATA INTO ESDS CLUSTER           *
//* *  IDCAMS2: DEFINE/BUILD ALTERNATE INDEXES & PATHS      *
//* *  COBUCLG2: READ DATA USING EACH INDEX                 *
//* *                                                       *
//* *********************************************************
//*
//IDCAMS   EXEC PGM=IDCAMS,REGION=4096K                        
//SYSPRINT DD  SYSOUT=*
//SYSIN    DD  *                                              
                                                              
  /* DELETE ESDS CLUSTER, IF IT EXISTS                      */
                                                              
  DELETE JAY01.MASTER.ESDS CLUSTER PURGE                  
  IF LASTCC = 8 THEN DO
     SET MAXCC = 0
     SET LASTCC = 0
     END
                                                              
  /* DEFINE ESDS CLUSTER                                    */
                                                              
  DEFINE CLUSTER (                                          - 
               NAME(JAY01.MASTER.ESDS)                      - 
               VOLUMES(PUB000)                              - 
               UNIQUE                                       -
               RECORDSIZE(148 148)                          - 
               RECORDS(50)                                  - 
               NONINDEXED )                                 - 
         DATA (                                             - 
               NAME(JAY01.MASTER.ESDS.DATA) )      
       
//COBUCLG1 EXEC COBUCLG,REGION.GO=2048K,CPARM1='LOAD,DMAP'              
//COB.SYSIN DD *
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. JOINREC.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. SEPTEMBER, 2022.
000500 DATE-COMPILED.
000550
000600 REMARKS. THIS PROGRAM READS 2 CARDS FROM SYSUT1, CONCATENATES THE
000700          SECOND TO THE END OF THE FIRST, THEN WRITES THE NEW
000800          RECORD TO SYSUT2.
000900
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER. IBM-370.
001300 OBJECT-COMPUTER. IBM-370.
001400
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700
001800     SELECT INPUT-FILE
001900         ASSIGN TO UT-S-SYSUT1.
002000
002100     SELECT OUTPUT-FILE
002200         ASSIGN TO UT-S-SYSUT2.
002300
002400 DATA DIVISION.
002500 FILE SECTION.
002600
002700 FD  INPUT-FILE
002800     LABEL RECORDS ARE STANDARD
002900     RECORDING MODE IS F
003000     RECORD CONTAINS 80 CHARACTERS
003100     BLOCK CONTAINS 0 RECORDS
003200     DATA RECORD IS INPUT-RECD.
003300 01  INPUT-RECD                  PIC X(80).
003400
003500 FD  OUTPUT-FILE
003600     LABEL RECORDS ARE STANDARD
003700     RECORDING MODE IS F
003800     RECORD CONTAINS 148 CHARACTERS
003900     BLOCK CONTAINS 0 RECORDS
004000     DATA RECORD IS OUTPUT-RECD.
004100 01  OUTPUT-RECD                 PIC X(148).
004200
004300 WORKING-STORAGE SECTION.
004400
004500 01  END-OF-INPUT-SWITCH         PIC X VALUE 'N'.
004600     88  END-OF-INPUT                  VALUE 'Y'.
004700
004800 01  WS-RECORD.
004900     02  WS-RECORD-1ST           PIC X(80).
005000     02  WS-RECORD-2ND           PIC X(68).
005100
005200 01  WS-EDIT-1                   PIC 9999.
005300
005400 01  WS-COUNTER-1                PIC 9(8) VALUE ZERO.
005500 01  WS-COUNTER-2                PIC 9(8) VALUE ZERO.
005600
005700 PROCEDURE DIVISION.
005800
005900 000-INITIATE.
006000     OPEN INPUT INPUT-FILE
006100          OUTPUT OUTPUT-FILE.
006200
006300 000-PROCESS.
006400     PERFORM 100-PROCESS-INPUT THRU 199-EXIT
006500       UNTIL END-OF-INPUT.
006600
006700 000-TERMINATE.
006800     CLOSE INPUT-FILE, OUTPUT-FILE.
006900     MOVE WS-COUNTER-1 TO WS-EDIT-1.
007000     DISPLAY WS-EDIT-1 ' RECORDS READ'.
007100     MOVE WS-COUNTER-2 TO WS-EDIT-1.
007200     DISPLAY WS-EDIT-1 ' RECORDS WRITTEN'.
007300     GOBACK.
007400* ------------------------------------------- PROGRAM EXIT POINT
007500
007600 100-PROCESS-INPUT.
007700     READ INPUT-FILE AT END MOVE 'Y' TO END-OF-INPUT-SWITCH.
007800     IF END-OF-INPUT GO TO 199-EXIT.
007900     ADD 1 TO WS-COUNTER-1.
008000     MOVE INPUT-RECD TO WS-RECORD-1ST.
008100     READ INPUT-FILE AT END MOVE 'Y' TO END-OF-INPUT-SWITCH.
008200     IF END-OF-INPUT GO TO 199-EXIT.
008300     ADD 1 TO WS-COUNTER-1.
008400     MOVE INPUT-RECD TO WS-RECORD-2ND.
008500     WRITE OUTPUT-RECD FROM WS-RECORD.
008600     ADD 1 TO WS-COUNTER-2.
008700 199-EXIT.
008800     EXIT.
008900
009000* ------------------------------------------- PERFORM EXIT POINT
//GO.SYSPRINT DD SYSOUT=*                                               
//GO.SYSOUT   DD SYSOUT=*                                               
//GO.SYSUDUMP DD SYSOUT=*                                               
//GO.SYSUT1 DD *
574258875John       TErvin     860 Sand Creek Street              FLWest Bradent
on      34210193109041920032519251213MErvin, John T.
628967391Michelle   VErickson  281 Jackson Blvd                   TNKnoxville
        37932194709261944060219070830FErickson, Michelle V.
757585718Patty      RAlexander 212 Burwell Place                  CTNorwalk
        06854192805231953120819171216FAlexander, Patty R.
522394818Lucy       AWhite     617 Shore Street                   NMAlbuquerque
        87108192511241920120619550212FWhite, Lucy A.
426188931Jesse      KRoss      417 Sunset Circle                  CTNorwalk
        06854192805231915061019080531MRoss, Jesse K.
619627118Louise     JGoodlow   512 Brandywine Place               GARoswell
        30075193303141909010319260211FGoodlow, Louise J.
633182664Rebecca    UHammond   617 Rosewood Place                 TXFort Worth
        76119197004291959081019870518FHammond, Rebecca U.
198587136Kimberly   OLabroie   316 Burwell Avenue                 NYBuffalo
        14225193512211920040519430622FLabroie, Kimberly O.
347185837Nelson     JJackson   915 Sun Meadow Court               CABerkeley
        94704190811201958112219270331MJackson, Nelson J.
528178859Virginia   KRoss      208 Millbrook Street               NCCharlotte
        28262194709061960063019450910FRoss, Virginia K.
857367651Harold     CConley    505 Coliseum Place                 TXFort Worth
        76119196206191953051519310917MConley, Harold C.
527875614Louis      TTucker    303 Bishop Court                   ALMontgomery
        36109193508261962070319310921MTucker, Louis T.
377431773Bill       ZGoodwin   213 Carbondale Blvd                TXStephenville
        76401194911281961070119410121MGoodwin, Bill Z.
919731934Robert     VThatcher  915 Jackson Blvd                   FLFort Lauderd
ale     33304192308101940091819300805MThatcher, Robert V.
548589791Cheryl     PGlassman  401 Rosa Linda Road                CTNorwalk
        06854196007151946121419260513FGlassman, Cheryl P.
328258762Clara      TShriver   316 Bayview Street                 CASan Diego
        92154194804021935033119460509FShriver, Clara T.
918584355Craig      EYaeger    713 Barnaby Place                  CANewport Beac
h       92663191801291934012219420719MYaeger, Craig E.
548368474Adolf      UAlexander 313 Charleston Road                NCCharlotte
        28262192812301960063019220604MAlexander, Adolf U.
235391647Joan       QNewton    814 Northcross Street              NVSparks
        89431192812301931030219630327FNewton, Joan Q.
431294133Michelle   BGerblick  401 Coliseum Street                MAPeabody
        01961193502161926060319610609FGerblick, Michelle B.
663383385Matthew    SDoren     914 Balboa Street                  MIDetroit
        48205193512211924100119471229MDoren, Matthew S.
363312694Laurie     VTucker    615 Southland Street               AZPrescott
        86314195806151937122119310917FTucker, Laurie V.
132835841Andrew     UStone     316 Northfield Street              NEKearney
        68848194405201927022119200520MStone, Andrew U.
468383742Marilyn    FEubanks   918 Allen Place                    OREugene
        97402192308101944060219640218FEubanks, Marilyn F.
214185587Matthew    DErickson  603 Garden Road                    CAPalm Desert
        92211195104211908040219350717MErickson, Matthew D.
184324763Tammy      PGarland   509 Kings Ridge Road               AKAnchorage
        99508194104141937122119390730FGarland, Tammy P.
453527364Russell    IMcCollum  561 Forest Blvd                    TXDenton
        76201193303141935030119490624MMcCollum, Russell I.
984672319Bill       XTrujillo  210 Northfield Place               GARoswell
        30075193709051918032919390206MTrujillo, Bill X.
356635856Joseph     AErwin     606 Walden Court                   SDSioux Falls
        57112193707121937033019550212MErwin, Joseph A.
727647183Michelle   ZBenson    608 Ridgeway Circle                CALos Angeles
        90077193902101950053119440629FBenson, Michelle Z.
385347244Heather    NLockett   901 Kings Ridge Street             NYBuffalo
        14225196007151942062419351001FLockett, Heather N.
818827383Troy       CHorton    602 Buckley Avenue                 SDSioux Falls
        57112192511241944011719490624MHorton, Troy C.
736261961Lucy       LMartin    404 Sherwood Court                 FLFort Lauderd
ale     33304193005311949070719310921FMartin, Lucy L.
611775693William    TMull      760 Caribbean Circle               NYRochester
        03840192508151946110619170622MMull, William T.
287615292Lucy       SJackson   404 Industrial Avenue              CAPasadena
        91186192303081944092519320411FJackson, Lucy S.
499116185Ronald     PBrockton  406 Sheridan Blvd                  IDBoise
        83714194306081928081019360604MBrockton, Ronald P.
486292814Sharon     UDrake     617 Rocky Top Avenue               WAEverett
        98204194302061928040719420713FDrake, Sharon U.
644283697Ann        NBrockton  315 Barnaby Court                  PAPittsburgh
        15226194303221922061919460819FBrockton, Ann N.
358175813Jill       WJackson   313 Parson Street                  DCWashington
        20009194107301942062419570809FJackson, Jill W.
951585882Scott      XHorton    203 Apple Valley Place             KYGreenville
        42345192305261929041619080712MHorton, Scott X.
138949393Kimberly   TGaston    914 Benson Avenue                  NYRochester
        03840196302201946121419600628FGaston, Kimberly T.
988852215Sharon     BAlan      510 Apple Valley Street            TNKnoxville
        37932192207261946052019251213FAlan, Sharon B.
772495714Laurie     VRodgers   512 Quail Court                    MTMissoula
        59802195409071941083019550212FRodgers, Laurie V.
363347692Dawn       LRight     210 Hillside Court                 CASan Diego
        92154194709261964031319180203FRight, Dawn L.
291919717Everett    EYaeger    512 Rosewood Court                 FLTampa
        33619192507061961070119291115MYaeger, Everett E.
285676861Laurie     DMeehan    817 River Oaks Place               TXStephenville
        76401197502221964070219340823FMeehan, Laurie D.
316478373ChristopherJFontaine  408 Hillside Street                ALMontgomery
        36109191801291948111419370108MFontaine, Christopher J.
551681732Laurie     RRight     520 Industrial Street              WIMadison
        53704194110031928062019620805FRight, Laurie R.
263599684Janet      IRandall   915 Burwell Street                 FLFort Lauderd
ale     33304194602201944111719420701FRandall, Janet I.
182663428Kevin      MAlexander 817 Main Street                    CALos Angeles
        90077194712081942062219180203MAlexander, Kevin M.
//GO.SYSUT2 DD DISP=(NEW,PASS),DSN=&&JOINED,UNIT=SYSDA,
//             DCB=(LRECL=148,BLKSIZE=1480,RECFM=FB),                   
//             SPACE=(TRK,(50))                                         
//IDCAMS2  EXEC PGM=IDCAMS,REGION=4096K                        
//SYSPRINT DD  SYSOUT=*
//SYSUT1   DD  DISP=(OLD,DELETE),DSN=&&JOINED
//SYSIN    DD  *                                              
  
  /* LOAD ESDS CLUSTER WITH JOINED RECORDS                */

  REPRO INFILE(SYSUT1) OUTDATASET(JAY01.MASTER.ESDS)

  /* ---------------------------------------------------- */

  /* DEFINE ALTERNATE INDEX #1 OVER ESDS:                 */
  /*        UNIQUE KEYS (STUDENT ID NUMBER)               */
                                                              
  DEFINE ALTERNATEINDEX (                                   - 
               NAME(JAY01.MASTER.ALTIX1)                    - 
               RELATE(JAY01.MASTER.ESDS)                    - 
               VOLUMES(PUB000)                              - 
               UNIQUE                                       -
               RECORDSIZE(18 18)                            - 
               TRACKS(15 15)                                - 
               KEYS(9 0)                                    - 
               UNIQUEKEY                                    -
               UPGRADE )                                    - 
         DATA (                                             - 
               NAME(JAY01.MASTER.ALTIX1.DATA) )             - 
         INDEX (                                            - 
               NAME(JAY01.MASTER.ALTIX1.INDEX) )              

  /* BUILD ALTERNATE INDEX #1                             */
                                                              
  BLDINDEX INDATASET(JAY01.MASTER.ESDS)                     - 
           OUTDATASET(JAY01.MASTER.ALTIX1)                     

  /* BUILD THE PATH FOR ALTERNATE INDEX #1                */
                                                              
  DEFINE PATH (                                             - 
               NAME(JAY01.MASTER.IDNUMBER.IX)               - 
               PATHENTRY(JAY01.MASTER.ALTIX1) )              

  /* ---------------------------------------------------- */

  /* DEFINE ALTERNATE INDEX #2 OVER ESDS:                 */
  /*        NONUNIQUE KEYS (STUDENT NAME [LAST,FIRST,     */
  /*                  MIDDLE INITIAL] OCCURS 1 TO 5 TIMES)*/
                                                              
  DEFINE ALTERNATEINDEX (                                   - 
               NAME(JAY01.MASTER.ALTIX2)                    - 
               RELATE(JAY01.MASTER.ESDS)                    - 
               VOLUMES(PUB000)                              - 
               UNIQUE                                       -
               RECORDSIZE(39 55)                            - 
               TRACKS(15 15)                                - 
               KEYS(30 118)                                 - 
               NONUNIQUEKEY                                 -
               UPGRADE )                                    - 
         DATA (                                             - 
               NAME(JAY01.MASTER.ALTIX2.DATA) )             - 
         INDEX (                                            - 
               NAME(JAY01.MASTER.ALTIX2.INDEX) )              

  /* BUILD ALTERNATE INDEX #2                             */
                                                              
  BLDINDEX INDATASET(JAY01.MASTER.ESDS)                     - 
           OUTDATASET(JAY01.MASTER.ALTIX2)                     

  /* BUILD THE PATH FOR ALTERNATE INDEX #2                */
                                                              
  DEFINE PATH (                                             - 
               NAME(JAY01.MASTER.NAME.IX)                   - 
               PATHENTRY(JAY01.MASTER.ALTIX2) )              

  /* ---------------------------------------------------- */

  /* DEFINE ALTERNATE INDEX #3 OVER ESDS:                 */
  /*        NONUNIQUE KEYS (LOCATION [STATE,CITY]         */
  /*                  OCCURS 1 TO 5 TIMES)                */

                                                              
  DEFINE ALTERNATEINDEX (                                   - 
               NAME(JAY01.MASTER.ALTIX3)                    - 
               RELATE(JAY01.MASTER.ESDS)                    - 
               VOLUMES(PUB000)                              - 
               UNIQUE                                       -
               RECORDSIZE(31 47)                            - 
               TRACKS(15 15)                                - 
               KEYS(22 66)                                  - 
               NONUNIQUEKEY                                 -
               UPGRADE )                                    - 
         DATA (                                             - 
               NAME(JAY01.MASTER.ALTIX3.DATA) )             - 
         INDEX (                                            - 
               NAME(JAY01.MASTER.ALTIX3.INDEX) )              

  /* BUILD ALTERNATE INDEX #3                             */
                                                              
  BLDINDEX INDATASET(JAY01.MASTER.ESDS)                     - 
           OUTDATASET(JAY01.MASTER.ALTIX3)                     

  /* BUILD THE PATH FOR ALTERNATE INDEX #3                */
                                                              
  DEFINE PATH (                                             - 
               NAME(JAY01.MASTER.CITY.IX)                   - 
               PATHENTRY(JAY01.MASTER.ALTIX3) )              

  /* ---------------------------------------------------- */

  /* DEFINE ALTERNATE INDEX #4 OVER ESDS:                 */
  /*        NONUNIQUE KEYS (ENROLLDATE OCCURS 1 TO 5      */
  /*                        TIMES                         */
                                                              
  DEFINE ALTERNATEINDEX (                                   - 
               NAME(JAY01.MASTER.ALTIX4)                    - 
               RELATE(JAY01.MASTER.ESDS)                    - 
               VOLUMES(PUB000)                              - 
               UNIQUE                                       -
               RECORDSIZE(17 33)                            - 
               TRACKS(15 15)                                - 
               KEYS(08 93)                                  - 
               NONUNIQUEKEY                                 -
               UPGRADE )                                    - 
         DATA (                                             - 
               NAME(JAY01.MASTER.ALTIX4.DATA) )             - 
         INDEX (                                            - 
               NAME(JAY01.MASTER.ALTIX4.INDEX) )              

  /* BUILD ALTERNATE INDEX #4                             */
                                                              
  BLDINDEX INDATASET(JAY01.MASTER.ESDS)                     - 
           OUTDATASET(JAY01.MASTER.ALTIX4)                     

  /* BUILD THE PATH FOR ALTERNATE INDEX #4                */
                                                              
  DEFINE PATH (                                             - 
               NAME(JAY01.MASTER.EDATE.IX)                  - 
               PATHENTRY(JAY01.MASTER.ALTIX4) )              

//COBUCLG2 EXEC COBUCLG,REGION.GO=2048K,CPARM1='LOAD,DMAP,LIB'
//COB.SYSIN DD *
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. KSDSREAD.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. SEPTEMBER, 2022.
000500 DATE-COMPILED.
000600
000700 REMARKS. BASED UPON THE ORIGINAL KSDSREAD PROGRAM INCLUDED WITH
000800          VSAMIO SOURCE, THIS PROGRAM READS AN ESDS CLUSTER 
000900          USING FOUR ALTERNATE INDEXES.
001200
001300 ENVIRONMENT DIVISION.
001400 CONFIGURATION SECTION.
001500 SOURCE-COMPUTER. IBM-370.
001600 OBJECT-COMPUTER. IBM-370.
001700
001800 INPUT-OUTPUT SECTION.
001900 FILE-CONTROL.
002000
002100 DATA DIVISION.
002200 FILE SECTION.
002300
002400 WORKING-STORAGE SECTION.
002500 77  END-OF-FILE-SWITCH          PIC X(1)    VALUE 'N'.
002600     88  END-OF-FILE                         VALUE 'Y'.
002700
002800 01  VSIO-PARAMETER-VALUES       COPY VSAMIO.
002900 01  ESDS-AKEY01                 COPY VSAMIOFB.
003000 01  ESDS-AKEY02                 COPY VSAMIOFB.
003100 01  ESDS-AKEY03                 COPY VSAMIOFB.
003200 01  ESDS-AKEY04                 COPY VSAMIOFB.
003300
003400 01  ESDS-RECORD-FIELDS.
003500     02  ESDS-STUDENT-NUMBER     PIC 9(09).
003600     02  ESDS-FIRST-NAME         PIC X(11).
003700     02  ESDS-MINITIAL           PIC X(01).
003800     02  ESDS-LAST-NAME          PIC X(10).
003900     02  ESDS-STREET             PIC X(35).
004000     02  ESDS-STATE-CITY.
004100         03  ESDS-STATE          PIC X(02).
004200         03  ESDS-CITY           PIC X(20).
004300     02  ESDS-ZIPCODE            PIC X(05).
004400     02  ESDS-DATE1              PIC X(08).
004500     02  ESDS-DATE2              PIC X(08).
004600     02  ESDS-DATE3              PIC X(08).
004700     02  ESDS-GENDER             PIC X(01).
004800     02  ESDS-PRINT-NAME         PIC X(30).
004900
005000 PROCEDURE DIVISION.
005100
005200     PERFORM 000-INITIATE-K1 THRU 030-EXIT.
005300     PERFORM 100-INITIATE-K2 THRU 130-EXIT.
005400     PERFORM 200-INITIATE-K3 THRU 230-EXIT.
005500     PERFORM 300-INITIATE-K4 THRU 330-EXIT.
005600     GOBACK.
005700
005800 000-INITIATE-K1.
005900
006000     DISPLAY 'READING ESDS SEQUENTIALLY USING AIX #1'.
006100     DISPLAY '--------------------------------------'.
006200     DISPLAY ' '.
006300
006400     MOVE 'ESAKEY1' TO VSIO-DDNAME OF ESDS-AKEY01.
006500     MOVE VSIO-KSDS TO VSIO-ORGANIZATION OF ESDS-AKEY01.
006600     MOVE VSIO-SEQUENTIAL TO VSIO-ACCESS OF ESDS-AKEY01.
006700     MOVE VSIO-INPUT TO VSIO-MODE OF ESDS-AKEY01.
006800     MOVE +148 TO VSIO-RECORD-LENGTH OF ESDS-AKEY01.
006900     MOVE +0 TO VSIO-KEY-POSITION OF ESDS-AKEY01.
007000     MOVE +9 TO VSIO-KEY-LENGTH OF ESDS-AKEY01.
007100     MOVE VSIO-OPEN TO VSIO-COMMAND.
007200     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY01,
007300                         ESDS-RECORD-FIELDS.
007400*    END-CALL.
007500     IF NOT VSIO-SUCCESS
007600         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
007700                 VSIO-COMMAND
007800         EXHIBIT NAMED VSIO-RETURN-CODE,
007900         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
008000                       VSIO-VSAM-FUNCTION-CODE,
008100                       VSIO-VSAM-FEEDBACK-CODE
008200         STOP RUN.
008300*    END-IF.
008400
008500 010-PROCESS-K1.
008600
008700     MOVE 'N' TO END-OF-FILE-SWITCH.
008800     PERFORM 910-PROCESS-K1
008900        THRU 919-EXIT
009000       UNTIL END-OF-FILE.
009100*    END-PERFORM.
009200
009300     DISPLAY '--------------------------------------'.
009400     DISPLAY ' '.
009500
009600 020-TERMINATE-K1.
009700
009800     MOVE VSIO-CLOSE TO VSIO-COMMAND.
009900     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY01,
010000                         ESDS-RECORD-FIELDS.
010100*    END-CALL.
010200     IF NOT VSIO-SUCCESS
010300         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
010400                 VSIO-COMMAND
010500         EXHIBIT NAMED VSIO-RETURN-CODE,
010600         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
010700                       VSIO-VSAM-FUNCTION-CODE,
010800                       VSIO-VSAM-FEEDBACK-CODE.
010900*    END-IF.
011000
011100 030-EXIT.
011200     EXIT.
011300
011400 100-INITIATE-K2.
011500
011600     DISPLAY 'READING ESDS SEQUENTIALLY USING AIX #2'.
011700     DISPLAY '--------------------------------------'.
011800     DISPLAY ' '.
011900
012000     MOVE 'ESAKEY2' TO VSIO-DDNAME OF ESDS-AKEY02.
012100     MOVE VSIO-KSDS TO VSIO-ORGANIZATION OF ESDS-AKEY02.
012200     MOVE VSIO-SEQUENTIAL TO VSIO-ACCESS OF ESDS-AKEY02.
012300     MOVE VSIO-INPUT TO VSIO-MODE OF ESDS-AKEY02.
012400     MOVE +148 TO VSIO-RECORD-LENGTH OF ESDS-AKEY02.
012500     MOVE +118 TO VSIO-KEY-POSITION OF ESDS-AKEY02.
012600     MOVE +30 TO VSIO-KEY-LENGTH OF ESDS-AKEY02.
012700     MOVE VSIO-OPEN TO VSIO-COMMAND.
012800     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY02,
012900                         ESDS-RECORD-FIELDS.
013000*    END-CALL.
013100     IF NOT VSIO-SUCCESS
013200         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
013300                 VSIO-COMMAND
013400         EXHIBIT NAMED VSIO-RETURN-CODE,
013500         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
013600                       VSIO-VSAM-FUNCTION-CODE,
013700                       VSIO-VSAM-FEEDBACK-CODE
013800         STOP RUN.
013900*    END-IF.
014000
014100 110-PROCESS-K2.
014200
014300     MOVE 'N' TO END-OF-FILE-SWITCH.
014400     PERFORM 920-PROCESS-K2
014500        THRU 929-EXIT
014600       UNTIL END-OF-FILE.
014700*    END-PERFORM.
014800
014900     DISPLAY '--------------------------------------'.
015000     DISPLAY ' '.
015100
015200 120-TERMINATE-K2.
015300
015400     MOVE VSIO-CLOSE TO VSIO-COMMAND.
015500     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY02,
015600                         ESDS-RECORD-FIELDS.
015700*    END-CALL.
015800     IF NOT VSIO-SUCCESS
015900         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
016000                 VSIO-COMMAND
016100         EXHIBIT NAMED VSIO-RETURN-CODE,
016200         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
016300                       VSIO-VSAM-FUNCTION-CODE,
016400                       VSIO-VSAM-FEEDBACK-CODE.
016500*    END-IF.
016600
016700 130-EXIT.
016800     EXIT.
016900
017000 200-INITIATE-K3.
017100
017200     DISPLAY 'READING ESDS SEQUENTIALLY USING AIX #3'.
017300     DISPLAY '--------------------------------------'.
017400     DISPLAY ' '.
017500
017600     MOVE 'ESAKEY3' TO VSIO-DDNAME OF ESDS-AKEY03.
017700     MOVE VSIO-KSDS TO VSIO-ORGANIZATION OF ESDS-AKEY03.
017800     MOVE VSIO-SEQUENTIAL TO VSIO-ACCESS OF ESDS-AKEY03.
017900     MOVE VSIO-INPUT TO VSIO-MODE OF ESDS-AKEY03.
018000     MOVE +148 TO VSIO-RECORD-LENGTH OF ESDS-AKEY03.
018100     MOVE +66 TO VSIO-KEY-POSITION OF ESDS-AKEY03.
018200     MOVE +22 TO VSIO-KEY-LENGTH OF ESDS-AKEY03.
018300     MOVE VSIO-OPEN TO VSIO-COMMAND.
018400     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY03,
018500                         ESDS-RECORD-FIELDS.
018600*    END-CALL.
018700     IF NOT VSIO-SUCCESS
018800         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
018900                 VSIO-COMMAND
019000         EXHIBIT NAMED VSIO-RETURN-CODE,
019100         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
019200                       VSIO-VSAM-FUNCTION-CODE,
019300                       VSIO-VSAM-FEEDBACK-CODE
019400         STOP RUN.
019500*    END-IF.
019600
019700 210-PROCESS-K3.
019800
019900     MOVE 'N' TO END-OF-FILE-SWITCH.
020000     PERFORM 930-PROCESS-K3
020100        THRU 939-EXIT
020200       UNTIL END-OF-FILE.
020300*    END-PERFORM.
020400
020500     DISPLAY '--------------------------------------'.
020600     DISPLAY ' '.
020700
020800 220-TERMINATE-K3.
020900
021000     MOVE VSIO-CLOSE TO VSIO-COMMAND.
021100     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY03,
021200                         ESDS-RECORD-FIELDS.
021300*    END-CALL.
021400     IF NOT VSIO-SUCCESS
021500         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
021600                 VSIO-COMMAND
021700         EXHIBIT NAMED VSIO-RETURN-CODE,
021800         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
021900                       VSIO-VSAM-FUNCTION-CODE,
022000                       VSIO-VSAM-FEEDBACK-CODE.
022100*    END-IF.
022200
022300 230-EXIT.
022400     EXIT.
022500
022600 300-INITIATE-K4.
022700
022800     DISPLAY 'READING ESDS SEQUENTIALLY USING AIX #4'.
022900     DISPLAY '--------------------------------------'.
023000     DISPLAY ' '.
023100
023200     MOVE 'ESAKEY4' TO VSIO-DDNAME OF ESDS-AKEY04.
023300     MOVE VSIO-KSDS TO VSIO-ORGANIZATION OF ESDS-AKEY04.
023400     MOVE VSIO-SEQUENTIAL TO VSIO-ACCESS OF ESDS-AKEY04.
023500     MOVE VSIO-INPUT TO VSIO-MODE OF ESDS-AKEY04.
023600     MOVE +148 TO VSIO-RECORD-LENGTH OF ESDS-AKEY04.
023700     MOVE +93 TO VSIO-KEY-POSITION OF ESDS-AKEY04.
023800     MOVE +8 TO VSIO-KEY-LENGTH OF ESDS-AKEY04.
023900     MOVE VSIO-OPEN TO VSIO-COMMAND.
024000     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY04,
024100                         ESDS-RECORD-FIELDS.
024200*    END-CALL.
024300     IF NOT VSIO-SUCCESS
024400         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
024500                 VSIO-COMMAND
024600         EXHIBIT NAMED VSIO-RETURN-CODE,
024700         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
024800                       VSIO-VSAM-FUNCTION-CODE,
024900                       VSIO-VSAM-FEEDBACK-CODE
025000         STOP RUN.
025100*    END-IF.
025200
025300 310-PROCESS-K4.
025400
025500     MOVE 'N' TO END-OF-FILE-SWITCH.
025600     PERFORM 940-PROCESS-K4
025700        THRU 949-EXIT
025800       UNTIL END-OF-FILE.
025900*    END-PERFORM.
026000
026100     DISPLAY '--------------------------------------'.
026200     DISPLAY ' '.
026300
026400 320-TERMINATE-K4.
026500
026600     MOVE VSIO-CLOSE TO VSIO-COMMAND.
026700     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY04,
026800                         ESDS-RECORD-FIELDS.
026900*    END-CALL.
027000     IF NOT VSIO-SUCCESS
027100         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
027200                 VSIO-COMMAND
027300         EXHIBIT NAMED VSIO-RETURN-CODE,
027400         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
027500                       VSIO-VSAM-FUNCTION-CODE,
027600                       VSIO-VSAM-FEEDBACK-CODE.
027700*    END-IF.
027800
027900 330-EXIT.
028000     EXIT.
028100
028200 910-PROCESS-K1.
028300
028400     MOVE VSIO-READ TO VSIO-COMMAND.
028500     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY01,
028600                         ESDS-RECORD-FIELDS.
028700*    END-CALL.
028800
028900     IF NOT VSIO-SUCCESS
029000         IF VSIO-END-OF-FILE
029100             MOVE 'Y' TO END-OF-FILE-SWITCH
029200         ELSE
029300             DISPLAY 'VSAMIO ERROR OCCURRED DURING '
029400                     VSIO-COMMAND
029500             EXHIBIT NAMED VSIO-RETURN-CODE,
029600             EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
029700                           VSIO-VSAM-FUNCTION-CODE,
029800                           VSIO-VSAM-FEEDBACK-CODE
029900             MOVE 'Y' TO END-OF-FILE-SWITCH.
030000*        END-IF
030100*    END-IF.
030200
030300     IF NOT END-OF-FILE
030400         DISPLAY 'KEY: ' ESDS-STUDENT-NUMBER
030500         DISPLAY 'RECORD: ' ESDS-RECORD-FIELDS
030600         DISPLAY ' '.
030700*    END-IF.
030800
030900 919-EXIT.
031000     EXIT.
031100
031200 920-PROCESS-K2.
031300
031400     MOVE VSIO-READ TO VSIO-COMMAND.
031500     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY02,
031600                         ESDS-RECORD-FIELDS.
031700*    END-CALL.
031800
031900     IF NOT VSIO-SUCCESS
032000         IF VSIO-END-OF-FILE
032100             MOVE 'Y' TO END-OF-FILE-SWITCH
032200         ELSE
032300             DISPLAY 'VSAMIO ERROR OCCURRED DURING '
032400                     VSIO-COMMAND
032500             EXHIBIT NAMED VSIO-RETURN-CODE,
032600             EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
032700                           VSIO-VSAM-FUNCTION-CODE,
032800                           VSIO-VSAM-FEEDBACK-CODE
032900             MOVE 'Y' TO END-OF-FILE-SWITCH.
033000*        END-IF
033100*    END-IF.
033200
033300     IF NOT END-OF-FILE
033400         DISPLAY 'KEY: ' ESDS-PRINT-NAME
033500         DISPLAY 'RECORD: ' ESDS-RECORD-FIELDS
033600         DISPLAY ' '.
033700*    END-IF.
033800
033900 929-EXIT.
034000     EXIT.
034100
034200 930-PROCESS-K3.
034300
034400     MOVE VSIO-READ TO VSIO-COMMAND.
034500     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY03,
034600                         ESDS-RECORD-FIELDS.
034700*    END-CALL.
034800
034900     IF NOT VSIO-SUCCESS
035000         IF VSIO-END-OF-FILE
035100             MOVE 'Y' TO END-OF-FILE-SWITCH
035200         ELSE
035300             DISPLAY 'VSAMIO ERROR OCCURRED DURING '
035400                     VSIO-COMMAND
035500             EXHIBIT NAMED VSIO-RETURN-CODE,
035600             EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
035700                           VSIO-VSAM-FUNCTION-CODE,
035800                           VSIO-VSAM-FEEDBACK-CODE
035900             MOVE 'Y' TO END-OF-FILE-SWITCH.
036000*        END-IF
036100*    END-IF.
036200
036300     IF NOT END-OF-FILE
036400         DISPLAY 'KEY: ' ESDS-STATE-CITY
036500         DISPLAY 'RECORD: ' ESDS-RECORD-FIELDS
036600         DISPLAY ' '.
036700*    END-IF.
036800
036900 939-EXIT.
037000     EXIT.
037100
037200 940-PROCESS-K4.
037300
037400     MOVE VSIO-READ TO VSIO-COMMAND.
037500     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, ESDS-AKEY04,
037600                         ESDS-RECORD-FIELDS.
037700*    END-CALL.
037800
037900     IF NOT VSIO-SUCCESS
038000         IF VSIO-END-OF-FILE
038100             MOVE 'Y' TO END-OF-FILE-SWITCH
038200         ELSE
038300             DISPLAY 'VSAMIO ERROR OCCURRED DURING '
038400                     VSIO-COMMAND
038500             EXHIBIT NAMED VSIO-RETURN-CODE,
038600             EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
038700                           VSIO-VSAM-FUNCTION-CODE,
038800                           VSIO-VSAM-FEEDBACK-CODE
038900             MOVE 'Y' TO END-OF-FILE-SWITCH.
039000*        END-IF
039100*    END-IF.
039200
039300     IF NOT END-OF-FILE
039400         DISPLAY 'KEY: ' ESDS-DATE1
039500         DISPLAY 'RECORD: ' ESDS-RECORD-FIELDS
039600         DISPLAY ' '.
039700*    END-IF.
039800
039900 949-EXIT.
040000     EXIT.
040100
//COB.SYSLIB DD DISP=SHR,DSN=SYSC.VSAMIO.SOURCE
//LKED.SYSLIB DD DISP=SHR,DSN=SYSC.LINKLIB
//            DD DISP=SHR,DSN=SYSC.COBLIB
//GO.SYSPRINT DD SYSOUT=*
//GO.SYSOUT   DD SYSOUT=*
//GO.SYSUDUMP DD SYSOUT=*
//GO.ESAKEY1 DD DISP=SHR,DSN=JAY01.MASTER.IDNUMBER.IX
//GO.ESAKEY2 DD DISP=SHR,DSN=JAY01.MASTER.NAME.IX
//GO.ESAKEY3 DD DISP=SHR,DSN=JAY01.MASTER.CITY.IX
//GO.ESAKEY4 DD DISP=SHR,DSN=JAY01.MASTER.EDATE.IX
//                                                                      
